/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : July, 1997                                                     */
/* File Name : Vector.h                                                  */
/*************************************************************************/
/*************************************************************************/

#ifndef _VECTOR_H
#define _VECTOR_H

#include <iostream.h>

template<class T1>
class Vector
{  public :

     Vector();
     Vector(unsigned _capacity);
     Vector(const Vector<T1>&);
     ~Vector();

       //* Adds the given object
     void addElement(T1 _newElement);

       //* Gets the pointer of indexed objec.
     T1 *getElement(unsigned index);

       //* Removes the given object from the Vector
     removeElement(T1);

       //* Removes the given indexed object from the Vector
     removeElementAt(unsigned index);

     Vector<T1> operator=(const Vector<T1>&);

     operator==(const Vector<T1>&);

     friend ostream & operator<<(ostream&,const Vector<T1>&);

     void printMe(ostream&) const;

     unsigned getSize() const;


   private:

                T1  *data;
          unsigned  capacity;
          unsigned  currentCapacity;
	  unsigned  index;

     void dispose();
     void copyFrom(const Vector<T1>&);

}; // end of class Vector

#endif
